/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ObsBucketReplicationConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.9/docs/resources/obs_bucket_replication#agency ObsBucketReplication#agency}
    */
    readonly agency: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.9/docs/resources/obs_bucket_replication#bucket ObsBucketReplication#bucket}
    */
    readonly bucket: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.9/docs/resources/obs_bucket_replication#destination_bucket ObsBucketReplication#destination_bucket}
    */
    readonly destinationBucket: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.9/docs/resources/obs_bucket_replication#id ObsBucketReplication#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.9/docs/resources/obs_bucket_replication#region ObsBucketReplication#region}
    */
    readonly region?: string;
    /**
    * rule block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.9/docs/resources/obs_bucket_replication#rule ObsBucketReplication#rule}
    */
    readonly rule?: ObsBucketReplicationRule[] | cdktf.IResolvable;
}
export interface ObsBucketReplicationRule {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.9/docs/resources/obs_bucket_replication#delete_data ObsBucketReplication#delete_data}
    */
    readonly deleteData?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.9/docs/resources/obs_bucket_replication#enabled ObsBucketReplication#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.9/docs/resources/obs_bucket_replication#history_enabled ObsBucketReplication#history_enabled}
    */
    readonly historyEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.9/docs/resources/obs_bucket_replication#prefix ObsBucketReplication#prefix}
    */
    readonly prefix?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.9/docs/resources/obs_bucket_replication#storage_class ObsBucketReplication#storage_class}
    */
    readonly storageClass?: string;
}
export declare function obsBucketReplicationRuleToTerraform(struct?: ObsBucketReplicationRule | cdktf.IResolvable): any;
export declare function obsBucketReplicationRuleToHclTerraform(struct?: ObsBucketReplicationRule | cdktf.IResolvable): any;
export declare class ObsBucketReplicationRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ObsBucketReplicationRule | cdktf.IResolvable | undefined;
    set internalValue(value: ObsBucketReplicationRule | cdktf.IResolvable | undefined);
    private _deleteData?;
    get deleteData(): boolean | cdktf.IResolvable;
    set deleteData(value: boolean | cdktf.IResolvable);
    resetDeleteData(): void;
    get deleteDataInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _historyEnabled?;
    get historyEnabled(): boolean | cdktf.IResolvable;
    set historyEnabled(value: boolean | cdktf.IResolvable);
    resetHistoryEnabled(): void;
    get historyEnabledInput(): boolean | cdktf.IResolvable | undefined;
    get id(): string;
    private _prefix?;
    get prefix(): string;
    set prefix(value: string);
    resetPrefix(): void;
    get prefixInput(): string | undefined;
    private _storageClass?;
    get storageClass(): string;
    set storageClass(value: string);
    resetStorageClass(): void;
    get storageClassInput(): string | undefined;
}
export declare class ObsBucketReplicationRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ObsBucketReplicationRule[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ObsBucketReplicationRuleOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.9/docs/resources/obs_bucket_replication opentelekomcloud_obs_bucket_replication}
*/
export declare class ObsBucketReplication extends cdktf.TerraformResource {
    static readonly tfResourceType = "opentelekomcloud_obs_bucket_replication";
    /**
    * Generates CDKTF code for importing a ObsBucketReplication resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the ObsBucketReplication to import
    * @param importFromId The id of the existing ObsBucketReplication that should be imported. Refer to the {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.9/docs/resources/obs_bucket_replication#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the ObsBucketReplication to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/opentelekomcloud/opentelekomcloud/1.36.9/docs/resources/obs_bucket_replication opentelekomcloud_obs_bucket_replication} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ObsBucketReplicationConfig
    */
    constructor(scope: Construct, id: string, config: ObsBucketReplicationConfig);
    private _agency?;
    get agency(): string;
    set agency(value: string);
    get agencyInput(): string | undefined;
    private _bucket?;
    get bucket(): string;
    set bucket(value: string);
    get bucketInput(): string | undefined;
    private _destinationBucket?;
    get destinationBucket(): string;
    set destinationBucket(value: string);
    get destinationBucketInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _rule;
    get rule(): ObsBucketReplicationRuleList;
    putRule(value: ObsBucketReplicationRule[] | cdktf.IResolvable): void;
    resetRule(): void;
    get ruleInput(): cdktf.IResolvable | ObsBucketReplicationRule[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
